import { Options as Opts, Rule, Sanitizer, Transformer } from '../utils/rules';
type Options<I> = Opts & {
    original: boolean;
    default: (() => I) | I;
};
export declare class VBase<I> {
    #private;
    get forced(): boolean;
    static createType<C extends VBase<any>, A extends Array<any>>(c: new (...args: A) => C): (...args: A) => C;
    static createForcedType<C extends VBase<any>, A extends any[] = any[]>(c: new (...args: A) => C, conv: (arg: unknown) => ExtractI<C>): (...args: A) => C;
    protected clone(base: VBase<I>): this;
    parse(input: unknown, ignoreRulesIfNotRequired?: boolean): {
        valid: false;
        errors: string[];
        value: unknown;
        ignored: boolean;
    } | {
        errors: string[];
        valid: true;
        value: I;
        ignored: boolean;
    };
    addTyping(rule: Rule<I>): this;
    addRule(rule: Rule<I>): this;
    addSanitizer(sanitizer: Sanitizer<I>): this;
    protected _addTransform<T>(transformer: Transformer<I, T>): this;
    protected _setOption<K extends keyof Options<I>>(key: K, value: Options<I>[K]): this;
    protected _setForced(conv: (val: unknown) => I): this;
}
export type ExtractI<T extends VBase<any>> = T extends VBase<infer I> ? I : never;
export {};
