import { Transformer } from '../utils/rules';
import { ExtractI, VBase } from './base';
export declare class VCore<I> extends VBase<I> {
    constructor();
    original(): this;
    requiredIf(required: () => boolean): VCore<ExtractI<this> | undefined>;
    optional(): VCore<ExtractI<this> | undefined>;
    nullable(): VCore<ExtractI<this> | null>;
    nullish(): VCore<ExtractI<this> | null | undefined>;
    default(def: I | (() => I)): this;
    custom(fn: (v: I) => boolean, err?: string): this;
    eq(compare: I, comparer?: (val: any, compare: I) => boolean, err?: string): this;
    ne(compare: I, comparer?: (val: any, compare: I) => boolean, err?: string): this;
    in(array: Readonly<I[]>, comparer?: (val: any, arrayItem: I) => boolean, err?: string): this;
    nin(array: Readonly<I[]>, comparer?: (val: any, arrayItem: I) => boolean, err?: string): this;
    transform<T>(transformer: Transformer<I, T>): VCore<T>;
}
