"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VCore = void 0;
const rules_1 = require("../rules");
const differ_1 = require("../utils/differ");
const equality_1 = require("./../rules/equality");
const base_1 = require("./base");
class VCore extends base_1.VBase {
    constructor() {
        super();
    }
    original() {
        return this._setOption('original', true);
    }
    requiredIf(required) {
        return makePartial(this)
            ._setOption('required', required);
    }
    optional() {
        return makePartial(this)
            ._setOption('required', false);
    }
    nullable() {
        return makePartial(this)
            ._setOption('nullable', true);
    }
    nullish() {
        return this.optional().nullable();
    }
    default(def) {
        return this._setOption('default', def);
    }
    custom(fn, err) {
        return this.addRule((0, rules_1.isCustom)(fn, err));
    }
    eq(compare, comparer = differ_1.Differ.equal, err) {
        return this.addRule((0, equality_1.isEqualTo)(compare, comparer, err));
    }
    ne(compare, comparer = differ_1.Differ.equal, err) {
        return this.addRule((0, equality_1.isNotEqualTo)(compare, comparer, err));
    }
    in(array, comparer = differ_1.Differ.equal, err) {
        return this.addRule((0, rules_1.arrayContains)(array, comparer, err));
    }
    nin(array, comparer = differ_1.Differ.equal, err) {
        return this.addRule((0, equality_1.arrayNotContains)(array, comparer, err));
    }
    transform(transformer) {
        return new VCore()
            .clone(this)
            ._addTransform(transformer);
    }
}
exports.VCore = VCore;
const makePartial = (base) => base;
//# sourceMappingURL=core.js.map