import { VArray } from './arrays';
import { VBoolean } from './booleans';
import { VCore } from './core';
import { VFile } from './files';
import { VAnd, VDiscriminator, VOr } from './junctions';
import { VNumber } from './numbers';
import { VObject } from './objects';
import { VMap, VRecord } from './records';
import { VString } from './strings';
import { VTime } from './times';
import { VTuple } from './tuples';
export { VCore };
export declare const v: {
    is: <T>(value: T, comparer?: (val: any, comp: T) => boolean, err?: string) => VCore<T>;
    in: <T>(values: Readonly<T[]>, comparer?: (val: any, arrayItem: T) => boolean, err?: string) => VCore<T>;
    or: <T extends VCore<any>[]>(options: T, err?: string | undefined) => VOr<T>;
    and: <I>(options: VCore<I>[], err?: string | undefined) => VAnd<I>;
    string: (err?: string | undefined) => VString;
    discriminate: <D extends Record<string, VCore<any>>>(discriminator: (val: import("./base").ExtractI<D[keyof D]>) => string, schemas: D, err?: string | undefined) => VDiscriminator<D>;
    number: (err?: string | undefined) => VNumber;
    boolean: (err?: string | undefined) => VBoolean;
    time: <T extends import("./times").Timeable = import("./times").Timeable>(err?: string | undefined) => VTime<T>;
    file: (err?: string | undefined) => VFile;
    array: <I>(comparer: VCore<I>, err?: string | undefined) => VArray<I>;
    tuple: <T extends ReadonlyArray<VCore<any>>>(schema: readonly [...T], err?: string | undefined) => VTuple<T>;
    object: <T extends Record<string, VCore<any>>>(schema: T, trim?: boolean | undefined, err?: string | undefined) => VObject<T>;
    record: <VI>(vCom: VCore<VI>, err?: string | undefined) => VRecord<VI>;
    map: <KI, VI>(kCom: VCore<KI>, vCom: VCore<VI>, err?: string | undefined) => VMap<KI, VI>;
    null: (err?: string) => VCore<null>;
    undefined: (err?: string) => VCore<undefined>;
    instanceof: <T>(classDef: new () => T, err?: string) => VCore<T>;
    any: <T = any>() => VCore<T>;
    force: {
        string: (err?: string | undefined) => VString;
        number: (err?: string | undefined) => VNumber;
        boolean: (err?: string | undefined) => VBoolean;
        time: (err?: string | undefined) => VTime<Date>;
    };
};
