"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.v = exports.VCore = void 0;
const rules_1 = require("../rules");
const differ_1 = require("../utils/differ");
const arrays_1 = require("./arrays");
const base_1 = require("./base");
const booleans_1 = require("./booleans");
const core_1 = require("./core");
Object.defineProperty(exports, "VCore", { enumerable: true, get: function () { return core_1.VCore; } });
const files_1 = require("./files");
const junctions_1 = require("./junctions");
const numbers_1 = require("./numbers");
const objects_1 = require("./objects");
const records_1 = require("./records");
const strings_1 = require("./strings");
const times_1 = require("./times");
const tuples_1 = require("./tuples");
exports.v = {
    is: (value, comparer = differ_1.Differ.equal, err) => new core_1.VCore().eq(value, comparer, err),
    in: (values, comparer = differ_1.Differ.equal, err) => new core_1.VCore().in(values, comparer, err),
    or: base_1.VBase.createType(junctions_1.VOr),
    and: base_1.VBase.createType(junctions_1.VAnd),
    string: base_1.VBase.createType(strings_1.VString),
    discriminate: base_1.VBase.createType(junctions_1.VDiscriminator),
    number: base_1.VBase.createType(numbers_1.VNumber),
    boolean: base_1.VBase.createType(booleans_1.VBoolean),
    time: base_1.VBase.createType(times_1.VTime),
    file: base_1.VBase.createType(files_1.VFile),
    array: base_1.VBase.createType(arrays_1.VArray),
    tuple: base_1.VBase.createType(tuples_1.VTuple),
    object: base_1.VBase.createType(objects_1.VObject),
    record: base_1.VBase.createType(records_1.VRecord),
    map: base_1.VBase.createType(records_1.VMap),
    null: (err) => new core_1.VCore().addRule((0, rules_1.isNull)(err)),
    undefined: (err) => new core_1.VCore().addRule((0, rules_1.isUndefined)(err)),
    instanceof: (classDef, err) => new core_1.VCore().addRule((0, rules_1.isInstanceOf)(classDef, err)),
    any: () => new core_1.VCore(),
    force: {
        string: base_1.VBase.createForcedType(strings_1.VString, (v) => String(v)),
        number: base_1.VBase.createForcedType(numbers_1.VNumber, (v) => Number(v)),
        boolean: base_1.VBase.createForcedType(booleans_1.VBoolean, (v) => Boolean(v)),
        time: base_1.VBase.createForcedType(times_1.VTime, (v) => new Date(v))
    }
};
//# sourceMappingURL=index.js.map