"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VNumber = void 0;
const rules_1 = require("../rules");
const core_1 = require("./core");
class VNumber extends core_1.VCore {
    constructor(err) {
        super();
        this.addTyping((0, rules_1.isNumber)(err));
    }
    gt(value, err) {
        return this.addRule((0, rules_1.isMoreThan)(value, err));
    }
    gte(value, err) {
        return this.addRule((0, rules_1.isMoreThanOrEqualTo)(value, err));
    }
    lt(value, err) {
        return this.addRule((0, rules_1.isLessThan)(value, err));
    }
    lte(value, err) {
        return this.addRule((0, rules_1.isLessThanOrEqualTo)(value, err));
    }
    int(err) {
        return this.addRule((0, rules_1.isInt)(err));
    }
    round(dp = 0) {
        return this.addSanitizer((val) => Number(val.toFixed(dp)));
    }
}
exports.VNumber = VNumber;
//# sourceMappingURL=numbers.js.map