"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VTime = void 0;
const rules_1 = require("../rules");
const core_1 = require("./core");
class VTime extends core_1.VCore {
    constructor(err) {
        super();
        this.addTyping((0, rules_1.isTime)(err));
    }
    min(compare, err) {
        return this.addRule((0, rules_1.isLaterThan)(compare, err));
    }
    max(compare, err) {
        return this.addRule((0, rules_1.isEarlierThan)(compare, err));
    }
    asStamp() {
        return this.transform((v) => new Date(v).valueOf());
    }
    asString() {
        return this.transform((v) => new Date(v).toString());
    }
    asDate() {
        return this.transform((v) => new Date(v));
    }
}
exports.VTime = VTime;
//# sourceMappingURL=times.js.map