"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VTuple = void 0;
const rules_1 = require("../rules");
const rules_2 = require("../utils/rules");
const core_1 = require("./core");
class VTuple extends core_1.VCore {
    constructor(schema, err) {
        super();
        this.addTyping((0, rules_1.isArray)(err));
        this.addTyping((0, rules_2.makeRule)((value) => {
            const val = value;
            if (schema.length !== val.length)
                val.length = schema.length;
            const mapped = schema.reduce((acc, cur, i) => {
                const comp = cur.parse(val?.[i]);
                acc[0].push(comp.value);
                acc[1].push(comp.valid);
                return acc;
            }, [[], []]);
            return (0, rules_1.isTuple)(mapped[1].map((v) => () => v), err)(mapped[0]);
        }));
    }
}
exports.VTuple = VTuple;
//# sourceMappingURL=tuples.js.map