"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFile = exports.isVideo = exports.isAudio = exports.isImage = exports.imageMimeTypes = exports.audioMimeTypes = exports.videoMimeTypes = exports.fileMimeTypes = void 0;
const rules_1 = require("../utils/rules");
const mimes_json_1 = __importDefault(require("./mimes.json"));
exports.fileMimeTypes = Object.keys(mimes_json_1.default);
exports.videoMimeTypes = exports.fileMimeTypes.filter((mime) => mime.startsWith('video/'));
exports.audioMimeTypes = exports.fileMimeTypes.filter((mime) => mime.startsWith('audio/'));
exports.imageMimeTypes = exports.fileMimeTypes.filter((mime) => mime.startsWith('image/'));
const isImage = (error = 'is not a recognized image file') => (0, rules_1.makeRule)((file) => {
    const val = file;
    if (exports.imageMimeTypes.includes(val?.type))
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isImage = isImage;
const isAudio = (error = 'is not a recognized audio file') => (0, rules_1.makeRule)((file) => {
    const val = file;
    if (exports.audioMimeTypes.includes(val?.type))
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isAudio = isAudio;
const isVideo = (error = 'is not a recognized video file') => (0, rules_1.makeRule)((file) => {
    const val = file;
    if (exports.videoMimeTypes.includes(val?.type))
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isVideo = isVideo;
const isFile = (error = 'is not a recognized file') => (0, rules_1.makeRule)((file) => {
    const val = file;
    if (exports.fileMimeTypes.includes(val?.type))
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isFile = isFile;
//# sourceMappingURL=files.js.map