"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isMap = exports.isRecord = void 0;
const rules_1 = require("../utils/rules");
const types_1 = require("./types");
const parse = (value, entries, kCom, vCom, error) => {
    for (const entry of entries) {
        const [key, value] = entry;
        if (!kCom(key))
            return (0, rules_1.isInvalid)([error ?? `contains an invalid key ${String(key)}`], value);
        if (!vCom(value))
            return (0, rules_1.isInvalid)([error ?? `contains an invalid value for key ${String(key)}`], value);
    }
    return (0, rules_1.isValid)(value);
};
const isRecord = (com, error) => (0, rules_1.makeRule)((value) => parse(value, Object.entries(value ?? []), () => true, com, error));
exports.isRecord = isRecord;
const isMap = (kCom, vCom, error) => (0, rules_1.makeRule)((value) => {
    const v = (0, types_1.isInstanceOf)(Map)(value);
    if (!v.valid)
        return v;
    const val = value;
    return parse(val, [...val.entries() ?? []], kCom, vCom, error);
});
exports.isMap = isMap;
//# sourceMappingURL=records.js.map