"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEarlierThan = exports.isLaterThan = exports.isTime = void 0;
const rules_1 = require("../utils/rules");
const numbers_1 = require("./numbers");
const strings_1 = require("./strings");
const isTime = (error = 'is not a valid datetime') => (0, rules_1.makeRule)((value) => {
    const val = value;
    if ((0, numbers_1.isNumber)()(val instanceof Date ? val.valueOf() : val).valid)
        return (0, rules_1.isValid)(val);
    if ((0, strings_1.isString)()(val).valid)
        return (0, numbers_1.isNumber)()(Date.parse(val)).valid ? (0, rules_1.isValid)(val) : (0, rules_1.isInvalid)([error], val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isTime = isTime;
const isLaterThan = (compare, error = 'is not later than compared value') => (0, rules_1.makeRule)((value) => {
    const val = value;
    const date = new Date(val);
    const compareDate = new Date(compare);
    if (!(0, exports.isTime)()(date).valid)
        return (0, rules_1.isInvalid)(['is not a valid datetime'], val);
    if (!(0, exports.isTime)()(compareDate).valid)
        return (0, rules_1.isInvalid)(['compare is not a valid datetime'], val);
    if (date <= compareDate)
        return (0, rules_1.isInvalid)([error], val);
    return (0, rules_1.isValid)(val);
});
exports.isLaterThan = isLaterThan;
const isEarlierThan = (compare, error = 'is not earlier than compared value') => (0, rules_1.makeRule)((value) => {
    const val = value;
    const date = new Date(val);
    const compareDate = new Date(compare);
    if (!(0, exports.isTime)()(date).valid)
        return (0, rules_1.isInvalid)(['is not a valid datetime'], val);
    if (!(0, exports.isTime)()(compareDate).valid)
        return (0, rules_1.isInvalid)(['compare is not a valid datetime'], val);
    if (date >= compareDate)
        return (0, rules_1.isInvalid)([error], val);
    return (0, rules_1.isValid)(val);
});
exports.isEarlierThan = isEarlierThan;
//# sourceMappingURL=times.js.map