"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTuple = void 0;
const rules_1 = require("../utils/rules");
const arrays_1 = require("./arrays");
const isTuple = (comparer, error) => (0, rules_1.makeRule)((value) => {
    const val = value;
    const v = (0, arrays_1.isArray)()(val);
    if (!v.valid)
        return v;
    if (comparer.length !== val.length)
        return (0, rules_1.isInvalid)(['value length is not equal to comparer length'], val);
    const invIndex = comparer.findIndex((c, i) => !c(val[i], i));
    const invalid = invIndex !== -1;
    error = error ?? `contains an invalid value at index ${invIndex}`;
    return invalid ? (0, rules_1.isInvalid)([error], val) : (0, rules_1.isValid)(val);
});
exports.isTuple = isTuple;
//# sourceMappingURL=tuples.js.map