"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInstanceOf = exports.isBoolean = exports.isNull = exports.isUndefined = void 0;
const rules_1 = require("../utils/rules");
const isUndefined = (error = 'is not undefined') => (0, rules_1.makeRule)((value) => {
    const val = value;
    if (value === undefined)
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isUndefined = isUndefined;
const isNull = (error = 'is not null') => (0, rules_1.makeRule)((value) => {
    const val = value;
    if (val === null)
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isNull = isNull;
const isBoolean = (error = 'is not a boolean') => (0, rules_1.makeRule)((value) => {
    const val = value;
    if (val === true || val === false)
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isBoolean = isBoolean;
const isInstanceOf = (classDef, error) => (0, rules_1.makeRule)((value) => {
    error = error ?? `is not an instance of ${classDef.name}`;
    const val = value;
    if (val?.constructor === classDef)
        return (0, rules_1.isValid)(val);
    if (value instanceof classDef)
        return (0, rules_1.isValid)(val);
    return (0, rules_1.isInvalid)([error], val);
});
exports.isInstanceOf = isInstanceOf;
//# sourceMappingURL=types.js.map