"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClassPropertiesWrapper = void 0;
const util_1 = __importDefault(require("util"));
if (util_1.default?.inspect?.defaultOptions) {
    util_1.default.inspect.defaultOptions.depth = Number.MAX_SAFE_INTEGER;
    util_1.default.inspect.defaultOptions.getters = true;
    util_1.default.inspect.defaultOptions.numericSeparator = true;
}
const customInspectSymbol = Symbol.for('nodejs.util.inspect.custom');
class __Wrapped {
    constructor(keys, access = {
        get: (key, keys) => keys[key],
        set: (key, value, keys) => {
            keys[key] = value;
        }
    }) {
        Object.keys(keys).forEach((key) => {
            Object.defineProperty(this, key, {
                get: () => access.get(key, keys),
                set: (value) => {
                    access.set(key, value, keys);
                },
                enumerable: true,
                configurable: true,
            });
        });
    }
    [customInspectSymbol](_, options, inspect) {
        options.getters = true;
        options.numericSeparator = true;
        options.depth = Number.MAX_SAFE_INTEGER;
        return options.stylize(this.constructor.name, options) + ' ' + inspect(this.toJSON(), options);
    }
    toJSON() {
        const json = Object.assign({}, this);
        Object.getOwnPropertyNames(Object.getPrototypeOf(this))
            .filter((k) => k !== 'constructor')
            .forEach((key) => {
            const value = this[key];
            json[key] = value?.toJSON?.() ?? value;
        });
        return json;
    }
    toString() {
        return JSON.stringify(this.toJSON());
    }
}
function WrapWithProperties() {
    return __Wrapped;
}
class ClassPropertiesWrapper extends WrapWithProperties() {
}
exports.ClassPropertiesWrapper = ClassPropertiesWrapper;
//# sourceMappingURL=classes.js.map