"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Validator = void 0;
const rules_1 = require("../utils/rules");
class Validator {
    static and(rules, options) {
        return (0, rules_1.makeRule)((val) => {
            const value = val;
            let ignored = false;
            for (const rule of rules) {
                const valid = (0, rules_1.check)(value, rule, options);
                if (valid.ignored)
                    ignored = true;
                if (valid.valid)
                    continue;
                else
                    return valid;
            }
            return { valid: true, value: value, errors: [], ignored };
        });
    }
    static or(rules, options) {
        return (0, rules_1.makeRule)((val) => {
            const value = val;
            let ignored = false;
            for (const rule of rules) {
                const valid = (0, rules_1.check)(value, rule, options);
                if (valid.ignored)
                    ignored = true;
                if (valid.valid)
                    return valid;
                else
                    continue;
            }
            return { valid: false, value: value, errors: ['doesn\'t match any of the schema'], ignored };
        });
    }
}
exports.Validator = Validator;
//# sourceMappingURL=index.js.map